SystemOrganization addCategory: #FuelMooseExtensionBenchmarks!

Object subclass: #FLMooseBenchmarks
	instanceVariableNames: 'benchSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtensionBenchmarks'!

!FLMooseBenchmarks commentStamp: 'MarianoMartinezPeck 5/16/2011 20:36' prior: 0!
I implement benchmarks for comparing Fuel and MSE exporting and importing Moose models. 

The results are shown in Transcript. 

Warning: Running will remove all currently installed models. 

FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createLightModelForNetwork ] name: 'lightNetwork'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createLightModelForMorphic ] name: 'lightMorphic'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForNetwork ] name: 'Network'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForMorphic ] name: 'Morphic'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createLightModelForPharo ] name: 'lightPharo'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForMoose ] name: 'Moose'.
FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForPharo ] name: 'Pharo'. "Toooo huge"

If you only want to run Fuel benchmarks you can do any of the previous script but adding a "benchSelectors: #(runFLWith:)". For example:

FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForMorphic ] name: 'Morphic' benchSelectors: #(runFLWith:)

If you want to only run MSE serializer, then:

FLMooseBenchmarks new runWithModelInstalledWith: [ MooseScripts createModelForMorphic ] name: 'Morphic' benchSelectors: #(runMSEWith:)
!

!FLMooseBenchmarks class methodsFor: 'obsolete' stamp: 'MartinDias 11/24/2010 16:17'!
exportingScripts

| modelName model |

MoosePanel open.
MooseModel resetRoot.

MooseModel lanSampleModel install.
MooseScripts createLightModelForPharo. 
MooseScripts createModelForNetwork.

modelName := 'MerlinMooseModel'.
modelName := 'CompilerMooseModel'.
modelName := 'lightPharo'.
modelName := 'lanSampleModel'.
modelName := 'Network'.


model := MooseModel root entityStorage detect: [:each | each name = modelName ].


Smalltalk garbageCollect.
[ model exportToFLStream: (FileStream forceNewFileNamed: modelName, '.fuel2') ] timeToRun.   
"Compiler:
 20941
 18931
 22741
Merlin:
 5648
 5696
 4965
 7146
Lan:
 758
LightPharo:
 224104
Network:
 25619
"

Smalltalk garbageCollect.
[ model exportToFuelStream: (FileStream forceNewFileNamed: modelName, '.fuel') ] timeToRun.  
"Compiler: 
 96967
 91816
Lan:
 1451
"

Smalltalk garbageCollect.
[ model exportToMSEStream: (FileStream forceNewFileNamed: modelName, '.mse') ] timeToRun.  
"Compiler: 
 37867
 35946
 36580
Merlin:
 9151
Lan:
 910
LightPharo:
 330779
Network:
 45302
"
! !

!FLMooseBenchmarks class methodsFor: 'obsolete' stamp: 'MartinDias 11/24/2010 16:16'!
importingScripts

| modelName |

modelName := 'MerlinMooseModel'.
modelName := 'CompilerMooseModel'.
modelName := 'lightPharo'.
modelName := 'lanSampleModel'.
modelName := 'Network'.


Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Fuel2';
	importFromFLStream: (FileStream fileNamed: modelName, '.fuel2');
	install.
] timeToRun.  
"Compiler:
 4093
 5923
 4479
Merlin:
 1434
Lan:
 151
LightPharo:
 95555
Network:
 4605
"

Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Fuel';
	importFromFuelStream: (FileStream fileNamed: modelName, '.fuel');
	install.
] timeToRun.  
"Compiler: 
 12704
 21642
Lan:
 360
"


Smalltalk garbageCollect.
[ MooseModel new
	name: modelName, 'Mse';
	importFromMSEStream: (FileStream fileNamed: modelName, '.mse');
	install.
] timeToRun. 
"Compiler: 
 29796
 20498
 28742
Merlin:
 5284
Lan:
 534
LightPharo:
Network:
 38595
"

! !

!FLMooseBenchmarks methodsFor: 'printing' stamp: 'MartinDias 12/29/2010 16:24'!
addFileSizeOf: aStream titled: aTitle

	Transcript 
		nextPutAll: aTitle;
		nextPutAll: ' file size: ';
		nextPutAll: aStream contents byteSize printString "asBytesDescription";
		nextPutAll: ' bytes';
		cr;
		flush.! !

!FLMooseBenchmarks methodsFor: 'printing' stamp: 'MartinDias 12/29/2010 12:23'!
addModelInfoOf: aModel

	Transcript 
		nextPutAll: 'Model name: ';
		nextPutAll: aModel name; 
		cr;
		nextPutAll: 'Model size: ';
		nextPutAll: aModel size printString;
		cr;
		flush.
! !

!FLMooseBenchmarks methodsFor: 'printing' stamp: 'MartinDias 12/29/2010 11:27'!
addResultRunning: aBlock titled: aTitle

	Transcript 
		nextPutAll: aTitle;
		nextPutAll: ': ';
		nextPutAll: aBlock timeToRun printString;
		nextPutAll: ' ms';
		cr;
		flush.! !

!FLMooseBenchmarks methodsFor: 'printing' stamp: 'MartinDias 12/29/2010 12:21'!
addTimeToInstallModelWith: aBlock
	
	Transcript 
		nextPutAll: 'ST import: ';
		nextPutAll: aBlock timeToRun printString;
		nextPutAll: ' ms';
		cr;
		flush.! !

!FLMooseBenchmarks methodsFor: 'accessors' stamp: 'MarianoMartinezPeck 5/16/2011 20:29'!
benchSelectors
	benchSelectors ifNil: [ benchSelectors := self defaultBenchSelectors ].
	^ benchSelectors! !

!FLMooseBenchmarks methodsFor: 'accessors' stamp: 'MarianoMartinezPeck 5/16/2011 20:30'!
defaultBenchSelectors
	^ #(runMSEWith: runFLWith:)! !

!FLMooseBenchmarks methodsFor: 'accessors' stamp: 'MartinDias 11/26/2010 11:21'!
newStreamNamed: aFileName

	^ FileStream forceNewFileNamed: aFileName! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MartinDias 5/15/2011 15:04'!
runFLWith: aModel

	| aStream |

	aStream := (self newStreamNamed: aModel name, '.fl').
	self addResultRunning: [ aModel exportToFLStream: aStream ] titled: 'FL export'.

	aStream reset.
	self addResultRunning: [ MooseModel new importFromFLStream: aStream ] titled: 'FL import'.

	self addFileSizeOf: aStream titled: 'FL'.
	
	aStream close.
! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/29/2010 14:04'!
runGarbageCollector
	3 timesRepeat: [ Smalltalk garbageCollect ]! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MartinDias 5/15/2011 15:04'!
runMSEWith: aModel

	| aStream |

	aStream := (self newStreamNamed: aModel name, '.mse').
	self addResultRunning: [ aModel exportToMSEStream: aStream ] titled: 'MSE export'.

	aStream reset.
	self addResultRunning: [ MooseModel new importFromMSEStream: aStream ] titled: 'MSE import'.

	self addFileSizeOf: aStream titled: 'MSE'.
	
	aStream close.
! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MarianoMartinezPeck 5/16/2011 20:31'!
runWith: aModel

	MooseModel resetRoot.
	self runGarbageCollector.
	self addModelInfoOf: aModel.
	self benchSelectors
		do: [ :aBenchmarkSelector | 
			self runGarbageCollector.
			self perform: aBenchmarkSelector with: aModel ]
		displayingProgress: 'Running benchmarks'! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/29/2010 11:31'!
runWithInstalledModelNamed: aName

	self runWith: (MooseModel root entityStorage detect: [:each | each name = aName ])! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MartinDias 12/29/2010 11:40'!
runWithModelInstalledWith: aBlock name: aName

	self addTimeToInstallModelWith: aBlock.
	self runWithInstalledModelNamed: aName.! !

!FLMooseBenchmarks methodsFor: 'testing' stamp: 'MarianoMartinezPeck 5/16/2011 20:29'!
runWithModelInstalledWith: aBlock name: aName benchSelectors: aListOfBenchSelectors

	benchSelectors := aListOfBenchSelectors.
	self addTimeToInstallModelWith: aBlock.
	self runWithInstalledModelNamed: aName.! !
